/**
 * @license MIT
 * @version 0.2.1
 * @name jQuery Gantt Chart
 * @description jQuery Gantt Chart is a simple chart that implements gantt functionality as a jQuery component.
 * @author Bekhruz Otaev
 * @link https://github.com/uzbeki/jquery-gantt-chart/
 */
!function(e,t){"use strict";var a=864e5;Date.prototype.getWeekId=function(){var e=this.getFullYear(),t=this.getWeekOfYear(),a=this.getMonth();return 11===a&&1===t?e++:!a&&t>51&&e--,"dh-"+e+"-"+t},Date.prototype.getRepDate=function(e){switch(e){case"hours":case"days":default:return this.getTime();case"weeks":return this.getDayForWeek().getTime();case"months":return new Date(this.getFullYear(),this.getMonth(),1).getTime()}},Date.prototype.getDayOfYear=function(){var e=this.getFullYear();return(Date.UTC(e,this.getMonth(),this.getDate())-Date.UTC(e,0,0))/a};Date.prototype.getWeekOfYear=function(){var e=this.getFullYear(),t=this.getMonth(),a=this.getDate(),n=this.getDay(),l=4-n;return n<1&&(l-=7),l+7<3&&(l+=7),Math.ceil(new Date(e,t,a+l).getDayOfYear()/7)},Date.prototype.getDayForWeek=function(){var e=this.getDay(),t=1+(e<1?-7:0)-e;return new Date(this.getFullYear(),this.getMonth(),this.getDate()+t)},e.fn.gantt=function(t){var n=["hours","days","weeks","months"],l={cellSize:24,source:{},holidays:[],itemsPerPage:10,dow:["S","M","T","W","T","F","S"],months:["January","February","March","April","May","June","July","August","September","October","November","December"],navigate:"scroll",scrollToToday:!0,useCookie:!1,cookieKey:"jquery-gantt-chart",scale:"days",maxScale:"months",minScale:"hours",onItemClick:e=>{},onAddClick:(e,t)=>{},onRender:()=>{},onGetPage:async e=>{}};e.extend(l,t),l.useCookie=l.useCookie&&e.isFunction(e.cookie);var s={elementFromPoint:function(e,t){return document.elementFromPoint(e-window.scrollX,t-window.scrollY)},setData:(e,t)=>{e.data=t.data,e.pageNum=t.currentPage,e.pageCount=t.pageCount,e.totalItems=t.totalItems,l.itemsPerPage=t.itemsPerPage},create:function(t){"string"!=typeof l.source?(s.setData(t,l.source),s.init(t)):e.getJSON(l.source,(function(e){s.setData(t,e),s.init(t)}))},init:function(e){e.rowsNum=e.data.length,e.rowsOnLastPage=e.totalItems%l.itemsPerPage,e.dateStart=o.getMinDate(e),e.dateEnd=o.getMaxDate(e),s.render(e)},render:function(t){var a=e('<div class="fn-content"/>'),n=s.leftPanel(t);a.append(n);var i=s.rightPanel(t,n);a.append(i);var r=i.find(".dataPanel");t.gantt=e('<div class="fn-gantt" />').append(a),t.gantt.get(0).style.setProperty("--cell-size",o.getCellSize()+"px"),e(t).empty().append(t.gantt),t.canScroll=r.width()>i.width(),a.append(s.navigation(t)),s.fillData(t,r,n),l.useCookie&&e.cookie(l.cookieKey+"ScrollPos"),l.scrollToToday?s.navigateTo(t,"now"):s.updateProgressAndScroll(t,0),r.css({height:n.height()}),l.onRender()},leftPanel:function(t){var a=e('<div class="leftPanel"/>').append(e('<div class="row spacer"/>').css("height",o.getCellSize()*t.headerRows));const n=t.data.map(((e,t)=>{const a=e?.id?`data-id="${e.id}"`:"";return`<div class="row name row${t} ${e.desc?"":"fn-wide "+a}" \n                        id="rowheader${t}" data-offset="${t%l.itemsPerPage*o.getCellSize()}">\n                        <span class="fn-label ${e.cssClass||""}">${e.name||""}</span>\n                      </div>\n                      ${e.desc?`<div class="row desc row${t}" id="RowdId_${t}" ${a}>\n                          <span class="fn-label ${e.cssClass||""}">${e.desc}</span>\n                        </div>`:""}`}));return a.append(n.join(""))},dataPanel:function(t,a){var n=e('<div class="dataPanel" style="width: '+a+'px;"/>');return e(t).on("wheel",(e=>t.canScroll&&s.wheelScroll(t,e))),n.on("click",(a=>{var n;a.stopPropagation();var i=e(t).find(".fn-gantt .leftPanel"),r=e(t).find(".fn-gantt .dataPanel");switch(l.scale){case"months":n=o.getCellSize();break;case"hours":n=4*o.getCellSize();break;case"days":n=3*o.getCellSize();break;default:n=2*o.getCellSize()}var d=s.elementFromPoint(a.pageX,r.offset().top+n),c=(d="fn-label"===d.className?e(d.parentNode):e(d)).data("repdate"),g=s.elementFromPoint(i.offset().left+i.width()-10,a.pageY),h=(g=0===g.className.indexOf("fn-label")?e(g.parentNode):e(g)).data("id");l.onAddClick(new Date(c),t.data.find((e=>e.id===h)))})),n},rightPanel:function(t,a){var n=null,i=["sn","wd","wd","wd","wd","wd","sa"],r=[],d=0,c=[],g=0,h=[],u=0,v=[],p=[],w=new Date;w.setHours(0,0,0,0);var f,b,m,y,k,S,D,M,C,z,$=e('<div class="row gt_header"></div>');switch(l.scale){case"hours":for(z=(n=o.parseTimeRange(t.dateStart,t.dateEnd,t.scaleStep)).length*o.getCellSize(),m=n[0].getFullYear(),y=n[0].getMonth(),S=n[0],f=0,b=n.length;f<b;f++){var x=(D=n[f]).getFullYear();x!==m&&(r.push(`<div class="row year" style="width: ${o.getCellSize()*d}px">\n                        <div class="fn-label">${m}</div>\n                      </div>`),m=x,d=0),d++;var P=D.getMonth();P!==y&&(c.push(`<div class="row month" style="width: ${o.getCellSize()*g}px">\n                        <div class="fn-label">${l.months[y]}</div>\n                      </div>`),y=P,g=0),g++;var T=D.getDay(),A=S.getDay();T!==A&&(M=w-S==0?"today":o.isHoliday(S.getTime())?"holiday":i[A],h.push(`<div class="row date ${M}" style="width: ${o.getCellSize()*u}px">\n                        <div class="fn-label">${S.getDate()}</div>\n                      </div>`),v.push(`<div class="row day ${M}" style="width: ${o.getCellSize()*u}px">\n                        <div class="fn-label">${l.dow[A]}</div>\n                      </div>`),S=D,u=0),u++,M=i[T],o.isHoliday(D)&&(M="holiday"),p.push(`<div class="row day ${M}" id="dh-${D.getTime()}"\n                      data-offset="${f*o.getCellSize()}" data-repdate="${D.getRepDate(l.scale)}">\n                      <div class="fn-label">${D.getHours()}</div>\n                    </div>`)}r.push(`<div class="row year" style="width: ${o.getCellSize()*d}px">\n                    <div class="fn-label">${m}</div>\n                  </div>`),c.push(`<div class="row month" style="width: ${o.getCellSize()*g}px">\n                    <div class="fn-label">${l.months[y]}</div>\n                  </div>`),M=i[S.getDay()],o.isHoliday(S)&&(M="holiday"),h.push(`<div class="row date ${M}" style="width: ${o.getCellSize()*u}px">\n                    <div class="fn-label">${S.getDate()}</div>\n                  </div>`),v.push(`<div class="row day ${M}" style="width: ${o.getCellSize()*u}px">\n                    <div class="fn-label">${l.dow[S.getDay()]}</div>\n                  </div>`),(C=s.dataPanel(t,z)).append($.clone().html(r.join("")),$.clone().html(c.join("")),$.clone().html(h.join("")),$.clone().html(v.join("")),$.clone().html(p.join("")));break;case"weeks":var F;for(z=(n=o.parseWeeksRange(t.dateStart,t.dateEnd)).length*o.getCellSize(),m=n[0].getFullYear(),y=n[0].getMonth(),k=n[0].getWeekOfYear(),f=0,b=n.length;f<b;f++){k>(k=(D=n[f]).getWeekOfYear())&&(F=D.getDate()-1,F-=D.getMonth()?31:0,F/=7,r.push(`<div class="row year" style="width: ${o.getCellSize()*(d-F)}px">\n                        <div class="fn-label">${m}</div>\n                      </div>`),m++,d=F),d++,D.getMonth()!==y&&(F=D.getDate()-1,F/=7,c.push(`<div class="row month" style="width: ${o.getCellSize()*(g-F)}px">\n                        <div class="fn-label">${l.months[y]}</div>\n                      </div>`),y=D.getMonth(),g=F),g++;const e=w-D==0?"today":o.isHoliday(D)?"holiday":i[D.getDay()];h.push(`<div class="row day ${e}" id="${D.getWeekId()}" \n                      data-offset="${f*o.getCellSize()}" data-repdate="${D.getRepDate(l.scale)}">\n                      <div class="fn-label">${k}</div>\n                    </div>`)}r.push(`<div class="row year" style="width: ${o.getCellSize()*d}px">\n                    <div class="fn-label">${m}</div>\n                  </div>`),c.push(`<div class="row month" style="width: ${o.getCellSize()*g}px">\n                    <div class="fn-label">${l.months[y]}</div>\n                  </div>`),(C=s.dataPanel(t,z)).append($.clone().html(r.join("")),$.clone().html(c.join("")),$.clone().html(h.join("")));break;case"months":for(z=(n=o.parseMonthsRange(t.dateStart,t.dateEnd)).length*o.getCellSize(),m=n[0].getFullYear(),y=n[0].getMonth(),f=0,b=n.length;f<b;f++)(D=n[f]).getFullYear()!==m&&(r.push(`<div class="row year" style="width: ${o.getCellSize()*d}px">\n                        <div class="fn-label">${m}</div>\n                      </div>`),m=D.getFullYear(),d=0),d++,c.push(`<div class="row day wd" id="dh-${o.genId(D)}"\n                      data-offset="${f*o.getCellSize()}" data-repdate="${D.getRepDate(l.scale)}">\n                      ${1+D.getMonth()}\n                    </div>`);r.push(`<div class="row year" style="width: ${o.getCellSize()*d}px">\n                    <div class="fn-label">${m}</div>\n                  </div>`),(C=s.dataPanel(t,z)).append($.clone().html(r.join("")),$.clone().html(c.join("")));break;default:for(z=(n=o.generateDateRange(t.dateStart,t.dateEnd)).length*o.getCellSize(),m=n[0].getFullYear(),y=n[0].getMonth(),f=0,b=n.length;f<b;f++){(D=n[f]).getFullYear()!==m&&(r.push(`<div class="row year" style="width: ${o.getCellSize()*d}px">\n                        <div class="fn-label">${m}</div>\n                      </div>`),m=D.getFullYear(),d=0),d++,D.getMonth()!==y&&(c.push(`<div class="row month" style="width: ${o.getCellSize()*g}px">\n                        <div class="fn-label">${l.months[y]}</div>\n                      </div>`),y=D.getMonth(),g=0),g++,S=D.getDay();let e=w-D==0?"today":o.isHoliday(D)?"holiday":i[D.getDay()];o.isHoliday(D)&&(e="holiday"),h.push(`<div class="row date ${e}" id="dh-${o.genId(D)}"\n                      data-offset="${f*o.getCellSize()}" data-repdate="${D.getRepDate(l.scale)}">\n                      <div class="fn-label">${D.getDate()}</div>\n                    </div>`),v.push(`<div class="row day ${e}" id="dw-${o.genId(D)}" \n                      data-repdate="${D.getRepDate(l.scale)}">\n                      <div class="fn-label">${l.dow[S]}</div>\n                    </div>`)}r.push(`<div class="row year" style="width: ${o.getCellSize()*d}px">\n                    <div class="fn-label">${m}</div>\n                  </div>`),c.push(`<div class="row month" style="width: ${o.getCellSize()*g}px">\n                    <div class="fn-label">${l.months[y]}</div>\n                  </div>`),(C=s.dataPanel(t,z)).append($.clone().html(r.join("")),$.clone().html(c.join("")),$.clone().html(h.join("")),$.clone().html(v.join("")))}return e('<div class="rightPanel"></div>').append(C)},navigation:function(t){var a=null;return a="scroll"===l.navigate?e('<div class="navigate" />').append(e('<div class="nav-slider" />').append(e('<div class="nav-slider-left" />').append(e('<button type="button" class="btn btn-outline-dark nav-page-back" title="Previous page">\n                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-dash-circle" viewBox="0 0 16 16">\n                          <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14m0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16"/>\n                          <path d="M4 8a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7A.5.5 0 0 1 4 8"/>\n                        </svg></button>').on("click",(()=>s.navigatePage(t,-1)))).append(e(`<div class="page-number text-md-left"><span>${t.pageNum} / ${t.pageCount}</span></div>`)).append(e('<button type="button" class="btn btn-outline-dark nav-page-next" title="Next page">\n                          <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-plus-circle" viewBox="0 0 16 16">\n                            <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14m0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16"/>\n                            <path d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4"/>\n                          </svg></button>').on("click",(()=>s.navigatePage(t,1)))).append(e('<button type="button" class="btn btn-outline-dark nav-now" title="Show current time">\n                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-crosshair" viewBox="0 0 16 16">\n                          <path d="M8.5.5a.5.5 0 0 0-1 0v.518A7 7 0 0 0 1.018 7.5H.5a.5.5 0 0 0 0 1h.518A7 7 0 0 0 7.5 14.982v.518a.5.5 0 0 0 1 0v-.518A7 7 0 0 0 14.982 8.5h.518a.5.5 0 0 0 0-1h-.518A7 7 0 0 0 8.5 1.018zm-6.48 7A6 6 0 0 1 7.5 2.02v.48a.5.5 0 0 0 1 0v-.48a6 6 0 0 1 5.48 5.48h-.48a.5.5 0 0 0 0 1h.48a6 6 0 0 1-5.48 5.48v-.48a.5.5 0 0 0-1 0v.48A6 6 0 0 1 2.02 8.5h.48a.5.5 0 0 0 0-1zM8 10a2 2 0 1 0 0-4 2 2 0 0 0 0 4"/>\n                        </svg></button>').on("click",(()=>s.navigateTo(t,"now")))).append(e('<button type="button" class="btn btn-outline-dark nav-prev-week" title="Slide more to the left">\n                          <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-double-left" viewBox="0 0 16 16">\n                            <path fill-rule="evenodd" d="M8.354 1.646a.5.5 0 0 1 0 .708L2.707 8l5.647 5.646a.5.5 0 0 1-.708.708l-6-6a.5.5 0 0 1 0-.708l6-6a.5.5 0 0 1 .708 0"/>\n                            <path fill-rule="evenodd" d="M12.354 1.646a.5.5 0 0 1 0 .708L6.707 8l5.647 5.646a.5.5 0 0 1-.708.708l-6-6a.5.5 0 0 1 0-.708l6-6a.5.5 0 0 1 .708 0"/>\n                          </svg></button>').on("click",(function(){"hours"===l.scale?s.navigateTo(t,8*o.getCellSize()):"days"===l.scale?s.navigateTo(t,30*o.getCellSize()):"weeks"===l.scale?s.navigateTo(t,12*o.getCellSize()):"months"===l.scale&&s.navigateTo(t,6*o.getCellSize())}))).append(e('<button type="button" class="btn btn-outline-dark nav-prev-day" title="Slide to the left">\n                          <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-left" viewBox="0 0 16 16">\n                            <path fill-rule="evenodd" d="M11.354 1.646a.5.5 0 0 1 0 .708L5.707 8l5.647 5.646a.5.5 0 0 1-.708.708l-6-6a.5.5 0 0 1 0-.708l6-6a.5.5 0 0 1 .708 0"/>\n                          </svg></button>').on("click",(function(){"hours"===l.scale?s.navigateTo(t,4*o.getCellSize()):"days"===l.scale?s.navigateTo(t,7*o.getCellSize()):"weeks"===l.scale?s.navigateTo(t,4*o.getCellSize()):"months"===l.scale&&s.navigateTo(t,3*o.getCellSize())})))).append(s.progressBarLogic(t)).append(e('<div class="nav-slider-right" />').append(e('<button type="button" class="btn btn-outline-dark nav-next-day" title="Slide to the right">\n                          <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-right" viewBox="0 0 16 16">\n                            <path fill-rule="evenodd" d="M4.646 1.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708L10.293 8 4.646 2.354a.5.5 0 0 1 0-.708"/>\n                          </svg></button>').on("click",(function(){"hours"===l.scale?s.navigateTo(t,-4*o.getCellSize()):"days"===l.scale?s.navigateTo(t,-7*o.getCellSize()):"weeks"===l.scale?s.navigateTo(t,-4*o.getCellSize()):"months"===l.scale&&s.navigateTo(t,-3*o.getCellSize())}))).append(e('<button type="button" class="btn btn-outline-dark nav-next-week" title="Slide more to the right">\n                          <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-double-right" viewBox="0 0 16 16">\n                            <path fill-rule="evenodd" d="M3.646 1.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708L9.293 8 3.646 2.354a.5.5 0 0 1 0-.708"/>\n                            <path fill-rule="evenodd" d="M7.646 1.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708L13.293 8 7.646 2.354a.5.5 0 0 1 0-.708"/>\n                          </svg></button>').on("click",(function(){"hours"===l.scale?s.navigateTo(t,-8*o.getCellSize()):"days"===l.scale?s.navigateTo(t,-30*o.getCellSize()):"weeks"===l.scale?s.navigateTo(t,-12*o.getCellSize()):"months"===l.scale&&s.navigateTo(t,-6*o.getCellSize())}))).append(e('<button type="button" class="btn btn-outline-dark nav-zoomIn" title="Zoom in">\n                          <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-zoom-in" viewBox="0 0 16 16">\n                            <path fill-rule="evenodd" d="M6.5 12a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11M13 6.5a6.5 6.5 0 1 1-13 0 6.5 6.5 0 0 1 13 0"/>\n                            <path d="M10.344 11.742q.044.06.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1 1 0 0 0-.115-.1 6.5 6.5 0 0 1-1.398 1.4z"/>\n                            <path fill-rule="evenodd" d="M6.5 3a.5.5 0 0 1 .5.5V6h2.5a.5.5 0 0 1 0 1H7v2.5a.5.5 0 0 1-1 0V7H3.5a.5.5 0 0 1 0-1H6V3.5a.5.5 0 0 1 .5-.5"/>\n                          </svg></button>').on("click",(()=>s.zoomInOut(t,-1)))).append(e('<button type="button" class="btn btn-outline-dark nav-zoomOut" title="Zoom out">\n                          <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-zoom-out" viewBox="0 0 16 16">\n                            <path fill-rule="evenodd" d="M6.5 12a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11M13 6.5a6.5 6.5 0 1 1-13 0 6.5 6.5 0 0 1 13 0"/>\n                            <path d="M10.344 11.742q.044.06.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1 1 0 0 0-.115-.1 6.5 6.5 0 0 1-1.398 1.4z"/>\n                            <path fill-rule="evenodd" d="M3 6.5a.5.5 0 0 1 .5-.5h6a.5.5 0 0 1 0 1h-6a.5.5 0 0 1-.5-.5"/>\n                          </svg></button>').on("click",(()=>s.zoomInOut(t,1)))))):e('<div class="navigate" />').append(e('<button type="button" class="btn btn-outline-dark nav-page-back" title="Previous page">\n                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-dash-circle" viewBox="0 0 16 16">\n                  <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14m0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16"/>\n                  <path d="M4 8a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 0 1h-7A.5.5 0 0 1 4 8"/>\n                </svg></button>').on("click",(()=>s.navigatePage(t,-1)))).append(e(`<div class="page-number text-md-left"><span>${t.pageNum} / ${t.pageCount}</span></div>`)).append(e('<button type="button" class="btn btn-outline-dark nav-page-next" title="Next page">\n                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-plus-circle" viewBox="0 0 16 16">\n                      <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14m0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16"/>\n                      <path d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4"/>\n                    </svg></button>').on("click",(()=>s.navigatePage(t,1)))).append(e('<button type="button" class="btn btn-outline-dark nav-begin" title="Go to the beginning">\n                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-skip-backward-circle" viewBox="0 0 16 16">\n                      <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14m0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16"/>\n                      <path d="M11.729 5.055a.5.5 0 0 0-.52.038L8.5 7.028V5.5a.5.5 0 0 0-.79-.407L5 7.028V5.5a.5.5 0 0 0-1 0v5a.5.5 0 0 0 1 0V8.972l2.71 1.935a.5.5 0 0 0 .79-.407V8.972l2.71 1.935A.5.5 0 0 0 12 10.5v-5a.5.5 0 0 0-.271-.445"/>\n                    </svg></button>').on("click",(()=>s.navigateTo(t,"begin")))).append(e('<button type="button" class="btn btn-outline-dark nav-prev-week" title="Slide more to the left">\n                  <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-double-left" viewBox="0 0 16 16">\n                    <path fill-rule="evenodd" d="M8.354 1.646a.5.5 0 0 1 0 .708L2.707 8l5.647 5.646a.5.5 0 0 1-.708.708l-6-6a.5.5 0 0 1 0-.708l6-6a.5.5 0 0 1 .708 0"/>\n                    <path fill-rule="evenodd" d="M12.354 1.646a.5.5 0 0 1 0 .708L6.707 8l5.647 5.646a.5.5 0 0 1-.708.708l-6-6a.5.5 0 0 1 0-.708l6-6a.5.5 0 0 1 .708 0"/>\n                  </svg></button>').on("click",(()=>s.navigateTo(t,7*o.getCellSize())))).append(e('<button type="button" class="btn btn-outline-dark nav-prev-day" title="Slide to the left">\n                  <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-left" viewBox="0 0 16 16">\n                    <path fill-rule="evenodd" d="M11.354 1.646a.5.5 0 0 1 0 .708L5.707 8l5.647 5.646a.5.5 0 0 1-.708.708l-6-6a.5.5 0 0 1 0-.708l6-6a.5.5 0 0 1 .708 0"/>\n                  </svg></button>').on("click",(()=>s.navigateTo(t,o.getCellSize())))).append(e('<button type="button" class="btn btn-outline-dark nav-now" title="Show current time">\n                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-crosshair" viewBox="0 0 16 16">\n                      <path d="M8.5.5a.5.5 0 0 0-1 0v.518A7 7 0 0 0 1.018 7.5H.5a.5.5 0 0 0 0 1h.518A7 7 0 0 0 7.5 14.982v.518a.5.5 0 0 0 1 0v-.518A7 7 0 0 0 14.982 8.5h.518a.5.5 0 0 0 0-1h-.518A7 7 0 0 0 8.5 1.018zm-6.48 7A6 6 0 0 1 7.5 2.02v.48a.5.5 0 0 0 1 0v-.48a6 6 0 0 1 5.48 5.48h-.48a.5.5 0 0 0 0 1h.48a6 6 0 0 1-5.48 5.48v-.48a.5.5 0 0 0-1 0v.48A6 6 0 0 1 2.02 8.5h.48a.5.5 0 0 0 0-1zM8 10a2 2 0 1 0 0-4 2 2 0 0 0 0 4"/>\n                    </svg></button>').on("click",(()=>s.navigateTo(t,"now")))).append(e('<button type="button" class="btn btn-outline-dark nav-next-day" title="Slide to the right">\n                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-right" viewBox="0 0 16 16">\n                      <path fill-rule="evenodd" d="M4.646 1.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708L10.293 8 4.646 2.354a.5.5 0 0 1 0-.708"/>\n                    </svg></button>').on("click",(()=>s.navigateTo(t,-1*o.getCellSize())))).append(e('<button type="button" class="btn btn-outline-dark nav-next-week" title="Slide more to the right">\n                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-chevron-double-right" viewBox="0 0 16 16">\n                      <path fill-rule="evenodd" d="M3.646 1.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708L9.293 8 3.646 2.354a.5.5 0 0 1 0-.708"/>\n                      <path fill-rule="evenodd" d="M7.646 1.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708L13.293 8 7.646 2.354a.5.5 0 0 1 0-.708"/>\n                    </svg></button>').on("click",(()=>s.navigateTo(t,-7*o.getCellSize())))).append(e('<button type="button" class="btn btn-outline-dark nav-end" title="Go to the end">\n                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-skip-forward-circle" viewBox="0 0 16 16">\n                      <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14m0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16"/>\n                      <path d="M4.271 5.055a.5.5 0 0 1 .52.038L7.5 7.028V5.5a.5.5 0 0 1 .79-.407L11 7.028V5.5a.5.5 0 0 1 1 0v5a.5.5 0 0 1-1 0V8.972l-2.71 1.935a.5.5 0 0 1-.79-.407V8.972l-2.71 1.935A.5.5 0 0 1 4 10.5v-5a.5.5 0 0 1 .271-.445"/>\n                    </svg></button>').on("click",(()=>s.navigateTo(t,"end")))).append(e('<button type="button" class="btn btn-outline-dark nav-zoomIn" title="Zoom in">\n                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-zoom-in" viewBox="0 0 16 16">\n                      <path fill-rule="evenodd" d="M6.5 12a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11M13 6.5a6.5 6.5 0 1 1-13 0 6.5 6.5 0 0 1 13 0"/>\n                      <path d="M10.344 11.742q.044.06.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1 1 0 0 0-.115-.1 6.5 6.5 0 0 1-1.398 1.4z"/>\n                      <path fill-rule="evenodd" d="M6.5 3a.5.5 0 0 1 .5.5V6h2.5a.5.5 0 0 1 0 1H7v2.5a.5.5 0 0 1-1 0V7H3.5a.5.5 0 0 1 0-1H6V3.5a.5.5 0 0 1 .5-.5"/>\n                    </svg></button>').on("click",(()=>s.zoomInOut(t,-1)))).append(e('<button type="button" class="btn btn-outline-dark nav-zoomOut" title="Zoom out">\n                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-zoom-out" viewBox="0 0 16 16">\n                      <path fill-rule="evenodd" d="M6.5 12a5.5 5.5 0 1 0 0-11 5.5 5.5 0 0 0 0 11M13 6.5a6.5 6.5 0 1 1-13 0 6.5 6.5 0 0 1 13 0"/>\n                      <path d="M10.344 11.742q.044.06.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1 1 0 0 0-.115-.1 6.5 6.5 0 0 1-1.398 1.4z"/>\n                      <path fill-rule="evenodd" d="M3 6.5a.5.5 0 0 1 .5-.5h6a.5.5 0 0 1 0 1h-6a.5.5 0 0 1-.5-.5"/>\n                    </svg></button>').on("click",(()=>s.zoomInOut(t,1)))).append(s.progressBarLogic(t)),e('<div class="bottom"></div>').append(a)},progressBarLogic:function(t){const a=e(`\n              <div class="progress bg-light border border-dark ${"scroll"===l.navigate?"":"d-none"} \n                ${t.canScroll?"canScroll":""}" title="Click to set progress, or (ctrl) shift+wheel to scroll">\n                  <div class="progress-bar bg-light text-dark" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100">0%</div>\n                  <div class="circle" draggable="true" tabindex="0"></div>\n              </div>`);return a.find(".circle").get(0).addEventListener("mousedown",(function(e){if(!t.canScroll)return e.preventDefault();const n=e.clientX,l=o.getProgressBarProgress(t);function i(e){const o=e.clientX-n;let i=l+o/a.get(0).offsetWidth*100;s.updateProgressAndScroll(t,i)}function r(){document.removeEventListener("mousemove",i),document.removeEventListener("mouseup",r),document.removeEventListener("dragend",d)}function d(e){i(e),r()}document.addEventListener("mousemove",i),document.addEventListener("mouseup",r),document.addEventListener("dragend",d)})),a.get(0).addEventListener("click",(function(e){if(!t.canScroll)return e.preventDefault();const n=a.get(0).getBoundingClientRect(),l=(e.clientX-n.left)/n.width*100;s.updateProgressAndScroll(t,l)})),a},createProgressBar:function(t="",a,n,s){const o=e=>new Date(e).toLocaleString();var i=e(`<div class="bar" title="${t}" data-bs-content="From ${o(s.from)} to ${o(s.to)}">\n                <div class="fn-label">${t}</div>\n              </div>`).data("dataObj",s);return n&&i.addClass(n),i.on("click",(e=>{e.stopPropagation(),l.onItemClick(s)})),i},fillData:function(t,n,i){var r=o.getCellSize(),d=(r-18)/2,c=n.width();e.each(t.data,(function(i,g){e.each(g.values,(function(g,h){var u,v,p,w,f,b,m,y,k,S,D;switch(l.scale){case"hours":b=o.genId(o.dateDeserialize(h.from),t.scaleStep),v=e(t).find("#dh-"+b),m=o.genId(o.dateDeserialize(h.to),t.scaleStep),p=e(t).find("#dh-"+m),w=v.data("offset"),f=p.data("offset"),y=Math.floor((f-w)/r)+1,k=100*(r*y-1)/c,u=s.createProgressBar(h.label,h.desc,h.customClass,h),S=e(t).find("#rowheader"+i),D=5*r+d+S.data("offset"),u.css({top:D,left:Math.floor(w),width:k+"%"}),n.append(u);break;case"weeks":b=o.dateDeserialize(h.from),m=o.dateDeserialize(h.to),w=(v=e(t).find("#"+b.getWeekId())).data("offset"),f=(p=e(t).find("#"+m.getWeekId())).data("offset"),y=Math.round((f-w)/r)+1,k=100*(r*y-1)/c,u=s.createProgressBar(h.label,h.desc,h.customClass,h),S=e(t).find("#rowheader"+i),D=3*r+d+S.data("offset"),u.css({top:D,left:Math.floor(w),width:k+"%"}),n.append(u);break;case"months":b=o.dateDeserialize(h.from),m=o.dateDeserialize(h.to),b.getDate()<=3&&0===b.getMonth()&&b.setDate(b.getDate()+4),b.getDate()<=3&&0===b.getMonth()&&b.setDate(b.getDate()+4),m.getDate()<=3&&0===m.getMonth()&&m.setDate(m.getDate()+4),w=(v=e(t).find("#dh-"+o.genId(b))).data("offset"),f=(p=e(t).find("#dh-"+o.genId(m))).data("offset"),y=Math.round((f-w)/r)+1,k=100*(r*y-1)/c,u=s.createProgressBar(h.label,h.desc,h.customClass,h),S=e(t).find("#rowheader"+i),D=2*r+d+S.data("offset"),u.css({top:D,left:Math.floor(w),width:k+"%"}),n.append(u);break;default:b=o.genId(o.dateDeserialize(h.from)),m=o.genId(o.dateDeserialize(h.to)),w=(v=e(t).find("#dh-"+b)).data("offset"),y=Math.round((m-b)/a)+1,k=100*(r*y-1)/c,u=s.createProgressBar(h.label,h.desc,h.customClass,h),S=e(t).find("#rowheader"+i),D=4*r+d+S.data("offset"),u.css({top:D,left:Math.floor(w),width:k+"%"}),n.append(u)}var M=u.find(".fn-label");if(M.length){var C=function(e){try{var t=(e=e.replace("rgb(","").replace(")","")).split(","),a=parseInt(t[0],10),n=parseInt(t[1],10),l=parseInt(t[2],10),s=Math.round(.9*(255-(.299*a+.587*n+.114*l)));return"rgb("+s+", "+s+", "+s+")"}catch(e){return""}}(u.css("backgroundColor"));M.css("color",C)}}))}))},navigateTo:function(t,a){var n=e(t).find(".fn-gantt .rightPanel"),l=n.find(".dataPanel");const o=n.width()-l.width();let i=0;switch(a){case"begin":i=0;break;case"end":i=100;break;case"now":if(!t.canScroll||!l.find(".today").length)return!1;a=l.find(".today").offset().left-l.offset().left,(a*=-1)>0?a=0:a<o&&(a=o),i=100*a/o;break;default:i=100*(a=parseInt(l.css("left").replace("px",""))+a)/o}s.updateProgressAndScroll(t,i)},navigatePage:function(e,t){const a=Math.min(Math.max(e.pageNum+t,1),e.pageCount);if(a===e.pageNum)return console.log("No more pages to navigate to");l.onGetPage(a).then((t=>{s.setData(e,t),s.init(e)}))},zoomInOut:function(t,a){var o=a<0,i=t.scaleStep+3*a;i={4:3,5:6,9:8,11:12}[i]||(i<1?1:i);var r=l.scale,d=t.headerRows;"hours"===l.scale&&i>=13?(r="days",d=4,i=13):"days"===l.scale&&o?(r="hours",d=5,i=12):"days"!==l.scale||o?"weeks"!==l.scale||o?"weeks"===l.scale&&o?(r="days",d=4,i=13):"months"===l.scale&&o&&(r="weeks",d=3,i=13):(r="months",d=2,i=14):(r="weeks",d=3,i=13),o&&n.indexOf(r)<n.indexOf(l.minScale)||!o&&n.indexOf(r)>n.indexOf(l.maxScale)||(t.scaleStep=i,l.scale=r,t.headerRows=d,l.useCookie&&(e.cookie(l.cookieKey+"CurrentScale",l.scale),e.cookie(l.cookieKey+"ScrollPos",null))),s.init(t)},wheelScroll:function(e,t){if(!t.shiftKey)return;t.preventDefault();const a=t.ctrlKey||t.metaKey||t.originalEvent.ctrlKey||t.originalEvent.metaKey,n=Math.sign(t.deltaY||t.originalEvent.deltaY)||0;let i=a?5*n:1*n;"hours"===l.scale&&(i*=.25);const r=o.getProgressBarProgress(e)+i;s.updateProgressAndScroll(e,r)},updateProgressAndScroll:function(t,a=0){if(!1===t.canScroll)return;const n=o.setProgressBarProgress(t,a),l=e(t).find(".rightPanel"),s=l.find(".dataPanel"),i=(l.width()-s.width())*n/100;s.css("left",`${i}px`)}},o={getProgressBarProgress:function(t){return parseFloat(e(t).find(".progress").get(0).style.getPropertyValue("--progress"))||0},setProgressBarProgress:function(t,a){const n=o.clamp(a);return e(t).find(".progress").get(0).style.setProperty("--progress",`${n}%`),e(t).find(".progress-bar").text(`${Math.round(n)}%`),n},getMaxDate:function(t){var a,n=null;switch(e.each(t.data,(function(t,a){e.each(a.values,(function(e,t){var a=o.dateDeserialize(t.to);isNaN(a)||(n=n<a?a:n)}))})),n=n||new Date,l.scale){case"hours":n.setHours(Math.ceil(n.getHours()/t.scaleStep)*t.scaleStep),n.setHours(n.getHours()+3*t.scaleStep);break;case"weeks":a=new Date(n.getTime()),a=new Date(a.setDate(a.getDate()+21));var s=7*Math.floor(a.getDate()/7);n=new Date(a.getFullYear(),a.getMonth(),0===s?4:s-3);break;case"months":(a=new Date(n.getFullYear(),n.getMonth(),1)).setMonth(a.getMonth()+2),n=new Date(a.getFullYear(),a.getMonth(),1);break;default:n.setHours(0),n.setDate(n.getDate()+3)}return n},getMinDate:function(t){var a=null;switch(e.each(t.data,(function(t,n){e.each(n.values,(function(e,t){var n=o.dateDeserialize(t.from);isNaN(n)||(a=a>n||null===a?n:a)}))})),a=a||new Date,l.scale){case"hours":a.setHours(Math.floor(a.getHours()/t.scaleStep)*t.scaleStep),a.setHours(a.getHours()-3*t.scaleStep);break;case"weeks":a.setHours(0,0,0,0),a.setDate(a.getDate()-21);break;case"months":a.setHours(0,0,0,0),a.setDate(1),a.setMonth(a.getMonth()-3);break;default:a.setHours(0,0,0,0),a.setDate(a.getDate()-3)}return a},generateDateRange:function(e,t){var a=e.getFullYear(),n=e.getMonth(),l=e.getDate(),s=[],o=0;do{s[o]=new Date(a,n,l+o)}while(s[o++]<t);return s},parseTimeRange:function(e,t,a){var n=e.getFullYear(),l=e.getMonth(),s=e.getDate(),o=e.getHours();o-=o%a;var i=[],r=0,d=0;do{i[d]=new Date(n,l,s,o+r++*a),d>0&&i[d].getHours()===i[d-1].getHours()&&d--}while(i[d++]<t);return i},parseWeeksRange:function(e,t){var a=e.getDayForWeek(),n=[],l=0;do{n[l++]=a.getDayForWeek(),a.setDate(a.getDate()+7)}while(a<=t);return n},parseMonthsRange:function(e,t){var a=new Date(e),n=[],l=0;do{n[l++]=new Date(a.getFullYear(),a.getMonth(),1),a.setMonth(a.getMonth()+1)}while(a<=t);return n},dateDeserialize:function(t){return"string"==typeof t&&(t=t.replace(/\/Date\((.*)\)\//,"$1"),t=e.isNumeric(t)?parseInt(t,10):e.trim(t)),new Date(t)},genId:function(t){switch(e.isNumeric(t)&&(t=new Date(t)),l.scale){case"hours":var a=t.getHours();return arguments.length>=2&&(a=Math.floor(t.getHours()/arguments[1])*arguments[1]),new Date(t.getFullYear(),t.getMonth(),t.getDate(),a).getTime();case"weeks":var n=t.getFullYear(),s=t.getWeekOfYear(),o=t.getMonth();return 11===o&&1===s?n++:!o&&s>51&&n--,n+"-"+s;case"months":return t.getFullYear()+"-"+t.getMonth();default:return new Date(t.getFullYear(),t.getMonth(),t.getDate()).getTime()}},_datesToDays:function(e){for(var t={},a=0,n=e.length;a<n;a++)t[o.dateDeserialize(e[a]).setHours(0,0,0,0)]=!0;return t},isHoliday:function(){if(!l.holidays||!l.holidays.length)return function(){return!1};var t=!1;return function(a){return t||(t=o._datesToDays(l.holidays)),!!t[e.isNumeric(a)?a:new Date(a.getFullYear(),a.getMonth(),a.getDate()).getTime()]}}(),getCellSize:function(){return l.cellSize},clamp:function(e,t=0,a=100){return Math.min(a,Math.max(t,e))}};this.each((function(){if(this.data=null,this.pageNum=0,this.pageCount=0,this.totalItems=0,this.rowsOnLastPage=0,this.rowsNum=0,this.dateStart=null,this.dateEnd=null,this.headerRows=null,l.useCookie){var t=e.cookie(l.cookieKey+"CurrentScale");t?l.scale=t:e.cookie(l.cookieKey+"CurrentScale",l.scale)}switch(l.scale){case"hours":this.headerRows=5,this.scaleStep=1;break;case"weeks":this.headerRows=3,this.scaleStep=13;break;case"months":this.headerRows=2,this.scaleStep=14;break;default:this.headerRows=4,this.scaleStep=13}this.canScroll=!0,this.gantt=null,s.create(this)}))}}(jQuery);